// BitTeszt - inicializál két változót, és kiírja
//            a ~,& , | és ^ művelet alkalmazásának
//            eredményét
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

int main(int nArgSzama, char* mszArg[])
{
    // a kimenet formátumának beállítása hexadecimálisra
    cout.unsetf(cout.dec);
    cout.setf(cout.hex);
  
   // két argumentum inicializálása
    int nArg1 = 0x78ABCDEF;
    int nArg2 = 0x12345678;

    // most egymás után végrehajtjuk az egyes műveleteket
    // először az egyoperandusú NOT operátort
    cout << " nArg1 = 0x" << nArg1  << endl;
    cout << "~nArg1 = 0x" << ~nArg1 << "\n" << endl;
    cout << " nArg2 = 0x" << nArg2  << endl;
    cout << "~nArg2 = 0x" << ~nArg2 << "\n" << endl;
 
    // most pedig a kétoperandusú operátorokat
    cout << "  0x" << nArg1 << "\n"
         << "& 0x" << nArg2 << "\n"
         << "  ----------"  << "\n"
         << "  0x" << (nArg1 & nArg2) << "\n"
         << endl;

    cout << "  0x" << nArg1 << "\n"
         << "| 0x" << nArg2 << "\n"
         << "  ----------"  << "\n"
         << "  0x" << (nArg1 | nArg2) << "\n"
         << endl;

    cout << "  0x" << nArg1 << "\n"
         << "^ 0x" << nArg2 << "\n"
         << "  ----------"  << "\n"
         << "  0x" << (nArg1 ^ nArg2) << "\n"
         << endl;
 
   // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
