// FüggvényBemutató - a függvények használatának
//                    bemutatása a BeágyazottBemutató program
//                    belső ciklusának leválasztásával egy
//                    külön függvénybe
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

// magyarázatMegjelenítése - a felhasználó emlékeztetése
//                           a játékszabályokra
void magyarazatMegjelenitese(void)
{
    cout << "Ez a program számok több sorozatát\n"
         << "összegzi. Minden sorozatot egy\n"
         << "negatív szám megadásával zárhatsz le.\n"
         << "A sorozatok bevitelének befejezéséhez adj meg\n"
         << "egy üres sorozatot.\n"
         << endl;
    return;
}

// sorozatÖsszegzése - a billentyűzeten megadott számsorozat
//                     összeadása, amíg a felhasználó nem ad meg egy
//                     negatív számot.
//                     visszatérési érték - a megadott számok összege
int sorozatOsszegzese(void)
{
    // végtelen ciklus
    int gyujto = 0;
    for(;;)
    {
        // a következő szám bekérése
        int nErtek = 0;
        cout << "Add meg a következő számot: ";
        cin  >> nErtek;
        // ha negatív...
        if (nErtek < 0)
        {
            // ...akkor kilépünk a ciklusból
            break;
        }
        // ...különben hozzáadjuk a számot
        // a gyűjtőhöz
        gyujto += nErtek;
    }
    // az összesített érték visszaadása
    return gyujto;
}
int main(int nArgSzama, char* mszArg[])
{
    // emlékeztető megjelenítése a felhasználó számára
    magyarazatMegjelenitese();
    // számok sorozatainak összegzése...
    for(;;)
    {
        // a billentyűzeten megadott számsorozat
        // összesítése
        cout << "Add meg a következő sorozatot" << endl;
        int osszesitettErtek = sorozatOsszegzese();
        // leállítjuk a ciklust, ha a sorozatOsszegzese()
        // nullát ad vissza
        if (osszesitettErtek == 0)
        {
            break;
        }

        // most kiírjuk az összesített eredményt
        cout << "Az összeg " << osszesitettErtek
             << endl << endl;
    }

    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
