// HónapokKiírása - a hónapok neveit írja ki
//                  egy konstans tömb indexe alapján
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

// definiálunk egy tömböt, amely a hónapok neveit tartalmazza
const char *const mszHonapok[] = {"érvénytelen",
                                 "Január",
                                 "Február",
                                 "Március",
                                 "Április",
                                 "Május",
                                 "Június",
                                 "Július",
                                 "Augusztus",
                                 "Szeptember",
                                 "Október",
                                 "November",
                                 "December"};
// intbolHonap() - a hónap nevét adja vissza
const char* intbolHonap(int nHonap)
{
    // először ellenőrizzük, hogy az érték a tartományon kívül esik-e
    if (nHonap < 1 || nHonap > 12)
    {
        return "érvénytelen";
    }
    // az nHonap érvényes - a hónap nevét adjuk vissza
    return mszHonapok[nHonap];
}

int main(int nArgSzama, char* mszArg[])
{
    cout << "Add meg a megjelenítendő hónap számát\n"
         << "(Adj meg egy negatív számot a kilépéshez)" << endl;
    for(;;)
    {
        cout << "Hónap?";
        int nHonap;
        cin >> nHonap;
        if (nHonap < 0)
        {
            break;
        }

        cout << "Ez a hónap "<<intbolHonap(nHonap)<<endl;
    }

    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}

