//  TagfüggvényMeghívása - egy olyan függvény definiálása és
//                         meghívása, amely a Hallgato osztály tagja
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;
class Hallgato
{
  public:
    // egy elvégzett kurzus hozzáadása a nyilvántartáshoz
    double kurzusHozzaadasa(int oraszam, double osztalyzat)
    {
        // kiszámítjuk az összes kurzus óraszámainak
        // összegét és az osztályzatok átlagát
        double sulyozottTanulmanyiAtlag;
        sulyozottTanulmanyiAtlag = feleviOraszam * tanulmanyiAtlag;
        // most adjuk hozzá az új kurzust
        feleviOraszam += oraszam;
        sulyozottTanulmanyiAtlag += osztalyzat * oraszam;
        tanulmanyiAtlag = sulyozottTanulmanyiAtlag / feleviOraszam;
        // adjuk vissza az új átlagot
        return tanulmanyiAtlag;
    }
    int  feleviOraszam;
    double tanulmanyiAtlag;
};

int main(int nArgSzama, char* mszArg[])
{
    // létrehozunk egy Hallgato objektumot, és inicializáljuk
    Hallgato h;
    h.feleviOraszam = 3;
    h.tanulmanyiAtlag = 3.0;
    // az értékek a hívás előtt
    cout << "Előtte: h = (" << h.feleviOraszam
         << ", " << h.tanulmanyiAtlag  << ")" << endl;
    // az alábbiakban alkalmazzuk a h objektum
    // adattagjaira a kurzusHozzaadasa() tagfüggvényt
    cout << "Hozzáadunk 3 órát, 4,0-s osztályzattal" << endl;
    h.kurzusHozzaadasa(3, 4.0); // meghívjuk a tagfüggvényt
    // az értékek így már módosultak
    cout << "Utána: h = (" << h.feleviOraszam
         << ", " << h.tanulmanyiAtlag  << ")" << endl;
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
