//  KonstruktorAlapértelmezéssel - több konstruktor gyakran
//                                 egyesíthető alapértelmezett
//                                 argumentumok megadásával
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;
class Hallgato
{
  public:
    Hallgato(const char *mNev = "Névtelen",
            int atadottOraszam = 0,
            double atadottAtlag = 0.0)
    {
        cout << "a következő hallgató felépítése: " << mNev << endl;
        nev = mNev;
        feleviOraszam = atadottOraszam;
        tanulmanyiAtlag = atadottAtlag;
    }
  protected:
    string  nev;
    int     feleviOraszam;
    double  tanulmanyiAtlag;
};

int main(int argszama, char* mArg[])
{
    // az alábbiakban három különböző konstruktort hívunk meg
    Hallgato nevtelen;
    Hallgato elsoeves("Sebes Mária");
    Hallgato cserediak("Kocsis Károly", 80, 2.5);
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
