//  KonstruktorTúlterhelés - több módot biztosítunk az
//                           osztálynak objektumok létrehozására
//                           a konstruktor túlterhelésével
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <string.h>
using namespace std;
class Hallgato
{
  public:
    Hallgato()
    {
        cout << "Névtelen hallgató felépítése" << endl;
        nev = "Névtelen";
        feleviOraszam = 0;
        tanulmanyiAtlag = 0.0;
    }
    Hallgato(const char *mNev)
    {
        cout << "a következő hallgató felépítése: " << mNev << endl;
        nev = mNev;
        feleviOraszam = 0;
        tanulmanyiAtlag = 0;
    }
    Hallgato(const char *mNev, int atadottOraszam, float atadottAtlag)
    {
        cout << "a következő hallgató felépítése: " << mNev << endl;
        nev = mNev;
        feleviOraszam = atadottOraszam;
        tanulmanyiAtlag = atadottAtlag;
    }
  protected:
    string  nev;
    int     feleviOraszam;
    float   tanulmanyiAtlag;
};
int main(int argszama, char* mArg[])
{
    // az alábbiakban három különböző konstruktort hívunk meg
    Hallgato nevtelen;
    Hallgato elsoeves("Sebes Mária");
    Hallgato cserediak("Kocsis Károly", 80, 2.5);
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
