//  StatikusFelépítése - szemlélteti, hogy a statikus objektumok
//                       csak egyszer épülnek fel
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;
class NemCsinalSemmit
{
  public:
    NemCsinalSemmit(int kezdeti) : nErtek(kezdeti)
    {
        cout << "NemCsinalSemmit felépítve a következő értékkel: "
             << kezdeti << endl;
    }
    ~NemCsinalSemmit()
    {
        cout << "NemCsinalSemmit objektum megsemmisítve" << endl;
    }
    int nErtek;
};
void fv(int i)
{
    cout << "Az fv függvénynek átadott érték: " << i << endl;
    static NemCsinalSemmit fv (i);
}
int main(int argszama, char* mArg[])
{
    fv(10);
    fv(20);
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
