//
//  TagokFelépítése - egy osztály átadhat argumentumokat
//                    a tagok konstruktorainak
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;
int kovHallgatoiAzon = 1000; // az első szabályos hallgatói azonosító
class HallgatoiAzon
{
  public:
    // az alapértelmezett konstruktor egymást követő azonosítókat oszt ki
    HallgatoiAzon()
    {
        ertek = kovHallgatoiAzon++;
        cout << "A kapott következő hallgatói azonosító: " << ertek << endl;
    }
    // az int konstruktorral a felhasználó oszthat ki azonosítót
    HallgatoiAzon(int azon)
    {
        ertek = azon;
        cout << "A következő hallgatói azonosító hozzárendelése: " << ertek << endl;
    }
  protected:
    int ertek;
};

class Hallgato
{
  public:
    Hallgato(const char* mNev)
    {
        cout << "a következő Hallgato felépítése: " << mNev << endl;
        nev = mNev;
        feleviOraszam = 0;
        tanulmanyiAtlag = 0.0;
    }
  // ...egyéb nyilvános tagok...
  protected:
    string        nev;
    int           feleviOraszam;
    double        tanulmanyiAtlag;
    HallgatoiAzon azon;
};
int main(int argszama, char* mArg[])
{
    // létrehozunk néhány hallgatót
    Hallgato h1("Morzsi");
    Hallgato h2("Bodri");
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
