//
//  TeljesMásolat  - szemlélteti a teljes másolat készítésének elvét
//                   az osztály minden tagjának másolásával
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

class Szemely
{
  public:
    Szemely(const char *mN)
    {
        cout << "Felépítés: " << mN << endl;
        mNev = new string(mN);
    }
    Szemely(Szemely& szemely)
    {
        cout << "Másolás: " << *(szemely.mNev) << endl;
        mNev = new string(*szemely.mNev);
    }
    ~Szemely()
    {
        cout << "Megsemmisítés: " << mNev
             << " (" << *mNev << ")" << endl;
        *mNev = "már megsemmisített memória";
        // delete mNev;
    }
 protected:
    string *mNev;
};

void fv()
{
    // létrehozunk egy új objektumot
    Szemely sz1("Ez_egy_nagyon_hosszú_név");
    // átmásoljuk az sz1 tartalmát az sz2-be
    Szemely sz2(sz1);
}
int main(int argszama, char* mArg[])
{
    cout << "Az fv() meghívása" << endl;
    fv();
    cout << "Újra a main() függvényben" << endl;
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
