// LépcsőzetesKivétel - a következő program szemléltet
//              egy példát a verem kifejtésére
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;
// néhány olyan függvény prototípusa, melyre később szükségünk lesz
void f1();
void f2();
void f3();
class Obj
{
  public:
    Obj(char c) : cimke(c)
    { cout << "A következő objektum felépítése: " << cimke << endl; }
    ~Obj()
    { cout << "A következő objektum megsemmisítése: " << cimke << endl; }
  protected:
    char cimke;
};
int main(int nArgSzama, char* mszArg[])
{
    f1();
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
void f1()
{
    Obj a('a');
    try
    {
        Obj b('b');
        f2();
    }
    catch(float f)
    {
        cout << "Float kezelése" << endl;
    }
    catch(int i)
    {
        cout << "Int kezelése" << endl;
    }
    catch(...)
    {
        cout << string("Általános kezelés") << endl;
    }
}
void f2()
{
    try
    {
        Obj c('c');
        f3();
    }
    catch(string uzenet)
    {
        cout << "String kezelése" << endl;
    }
}
void f3()
{
    Obj d('d');
    throw 10;
}
