// SablonVektor - egy egyszerű, sablonosított vektorosztály
template <class T>
class SablonVektor
{
 public:
    SablonVektor(int nTombMeret)
    {
        // tároljuk az elemek számát
        nMeret = nTombMeret;
        tomb = new T[nTombMeret];
        visszaallitas();
    }
    int meret() { return nIrasiIndex; }
    void visszaallitas() { nIrasiIndex = 0; nOlvasasiIndex = 0; }
    void hozzaadas(const T& objektum)
    {
        if (nIrasiIndex < nMeret)
        {
            tomb[nIrasiIndex++] = objektum;
        }
    }
    T& lekeres()
    {
        return tomb[nOlvasasiIndex++];
    }
  protected:
    int nMeret;
    int nIrasiIndex;
    int nOlvasasiIndex;
    T* tomb;
};
