// NincsPufferTúlcsordulás1 - ez a program úgy kerüli el a hekkelést,
//        hogy korlátozza a rögzített pufferbe való bevitel mennyiségét
#include <cstdio>
#include <cstdlib>
#include <fstream>
#include <iostream>
#include <cstring>
#include <string>
using namespace std;
// sztringBeolvasas - egy bementi sztringet olvas be a felhasználói promptról, 
//                    és visszaadja azt a hívónak
char* sztringBeolvasas(istream& cin)
{
    char puffer[64];
    // most betöltünk egy sztringet a fájlból
    // (de csak legfeljebb annyit, amennyi elfér a pufferben)
    int i;
    for(i = 0; i < 63; i++)
    {
        // beolvassuk a következő karaktert a pufferbe
        puffer[i] = cin.get();
        // kilépünk a ciklusból, ha a beolvasott karakter NULL vagy EOF
        if ((puffer[i] == 0) || cin.eof())
        {
            break;
        }
    }
    // biztosítjuk, hogy a puffer nullal záruljon
    puffer[i] = '\0';
    // a sztring másolatát adja vissza a hívónak
    char* mP = new char[strlen(puffer) + 1];
    if (mP != nullptr)
    {
        strcpy(mP, puffer);
    }
    return mP;
}

int main(int argszama, char* mArg[])
{
    // bekérjük a beolvasandó fájl nevét
    cout <<"Ez a program egy bemeneti fájlból olvassa be a bemenetet\n"
           "Add meg a fájl nevét:";
    string szNev;
    cin >> szNev;
    // megnyitjuk a fájlt
    ifstream c(szNev.c_str());
    if (!c)
    {
        cout << "\nHiba történt a bemeneti fájl megnyitásakor" << endl;
        exit(-1);
    }
    // beolvassuk a fájl tartalmát egy sztringbe
    char* mP = sztringBeolvasas(c);
    // kiírjuk, amit kaptunk
    cout << "\nA következőket sikerült beolvasni:\n" << mP << endl;
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    printf("Kész!");
    exit(0);
    return 0;
}
