// NégyzetBemutató - az olyan függvények használatának
//                   bemutatása, amelyek argumentumokat kezelnek
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

// negyzet - az argumentuma négyzetét adja vissza
//           doubleValt - a négyzetre emelendő érték
//           visszatérési érték - a doubleValt négyzete
double negyzet(double doubleValt)
{
    return doubleValt * doubleValt;
}

// magyarázatMegjelenítése - a felhasználó emlékeztetése
//                           a játékszabályokra
void magyarazatMegjelenitese(void)
{
    cout << "Ez a program összeadja a több számsorozat\n"
         << "négyzeteit. Minden sorozatot egy\n"
         << "negatív szám megadásával zárhatsz le.\n"
         << "A sorozatok bevitelének befejezéséhez adj meg\n"
         << "egy üres sorozatot.\n"
         << endl;
    return;
}

// negyzetSorozatOsszegzese - a billentyűzeten megadott számok
//                            négyzeteinek összegzése egy sorozatban,
//                            amíg a felhasználó negatív számot nem ad meg
double negyzetSorozatOsszegzese(void)
{
    // végtelen ciklus
    double gyujto = 0.0;
    for(;;)
    {
        // a következő szám bekérése
        double dErtek = 0;
        cout << "Add meg a következő számot: ";
        cin  >> dErtek;

        // ha negatív...
        if (dErtek < 0)
        {
            // ...akkor kilépünk a ciklusból
            break;
        }

        // ...különben kiszámítjuk a négyzetét
        double ertek = negyzet(dErtek);
        // most hozzáadjuk a négyzetét
        // a gyűjtőhöz
        gyujto += ertek;
    }
    // az összesített érték visszaadása
    return gyujto;
}
int main(int nArgSzama, char* mszArg[])
{
    magyarazatMegjelenitese();

    // A számok összegzésének folytatása...
    for(;;)
    {
        // a billentyűzeten megadott számsorozat
        // összesítése
        cout << "Add meg a következő sorozatot" << endl;
        double osszesitettErtek = negyzetSorozatOsszegzese();
        // leállítjuk a ciklust, ha a sorozat értéke nulla vagy negatív
        if (osszesitettErtek <= 0.0)
        {
            break;
        }

        // most kiírjuk az összesített eredményt
        cout << "\nA négyzetre emelet értékek összege "
             << osszesitettErtek << endl << endl;
    }

    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
