// Konkatenálás - két sztring összefűzése
//               középen a " - " elemmel
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

// prototípusdeklarációk
void sztringKonkat(char szCel[], const char szForras[]);

int main(int nArgSzama, char* mszArg[])
{
    // olvassuk be az első sztringet...
    char szSztring1[256];
    cout << "Add meg az 1. sztringet:";
    cin.getline(szSztring1, 128);

    // ...most pedig a második sztringet...
    char szSztring2[128];
    cout << "Add meg a 2. sztringet:";
    cin.getline(szSztring2, 128);
    // ...fűzzük össze a " - " elemet az elsővel...
    sztringKonkat(szSztring1, " - ");
    // ...most adjuk hozzá a második sztringet...
    sztringKonkat(szSztring1, szSztring2);
    // ...most pedig írjuk ki az eredményt
    cout << "\n" << szSztring1 << endl;
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}

// sztringKonkat - az szForras sztring hozzáfűzése
//                 az szCel sztring végéhez
void sztringKonkat(char szCel[], const char szForras[])
{
    // keressük meg az első sztring végét
    int celIndex = 0;
    while(szCel[celIndex])
    {
        celIndex++;
    }

    // fűzzük a másodikat az első végéhez
    int forrasIndex = 0;
    while(szForras[forrasIndex])
    {
        szCel[celIndex] =
            szForras[forrasIndex];
        celIndex++;
        forrasIndex++;
    }

    // fűzzük hozzá a záró nullt
    szCel[celIndex] = '\0';
}
