// MakróZavarok - szemléltet néhány problémát a
//                makródefiníciókkal kapcsolatban, illetve hogy
//                a beágyazott függvények ugyanazt az eredményt adják, csak meglepetések nélkül
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

// kommenteld ki az első makrót a második aktiválásához;
// a beágyazott függvény aktiválásához kommenteld ki mindkettőt
#define NEGYZET(X) X * X
#ifndef NEGYZET
#define NEGYZET(X) ((X) * (X))
#ifndef NEGYZET
    inline int NEGYZET(int X) {return X * X;}
#endif
#endif
int main(int nArgSzama, char* mszArg[])
{
    // próbáljunk ki egy egyszerű kifejezést
    int nNEGYZET = NEGYZET(2);
    cout << "NEGYZET(2) = " << nNEGYZET << endl;

    // itt egy olyan hiba, amely megoldható,
    // ha elég helyen használsz zárójeleket
    cout << "NEGYZET(1 + 2) = " << NEGYZET(1 + 2) << endl;

    // itt egy olyan hiba, amely nem oldható meg
    int i = 3;
    cout << "i = " << i << endl;
    nNEGYZET = NEGYZET(i++);
    cout << "NEGYZET(i++) = " << nNEGYZET << endl;
    cout << "now i = " << i << endl;

    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}

