// NévAdathalmaz - társított adatok tárolása
//                 egy objektumtömbben
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <string.h>
using namespace std;

// NevAdathalmaz - név- és bankkártyaadatokat
//                 tárol
class NevAdathalmaz
{
  public:
    char keresztnev[128];
    char vezeteknev[128];
    int  bankkartya;
};

int main(int nArgSzama, char* mszArg[])
{
    // lefoglaljuk a helyet 25 névadathalmaz számára
    const int MAX = 25;
    NevAdathalmaz nah[MAX];

    // betöltjük a keresztneveket, a vezetékneveket és
    // bankkártyaszámokat
    cout << "Név/bankkártyaadatok beolvasása\n"
         << "A kilépéshez írd be, hogy 'stop'" << endl;
    int index = 0;
    for(;index < MAX; index++)
    {
        cout << "\nAdd meg a keresztnevet:";
        cin  >> nah[index].keresztnev;

        // megszakítjuk a ciklust, ha a megadott keresztnév a "stop"
        if (strcmp(nah[index].keresztnev, "stop") == 0)
        {
            break;
        }

        cout << "Add meg a vezetéknevet:";
        cin  >> nah[index].vezeteknev;

        cout << "Add meg a bankkártyaszámot:";
        cin  >>nah[index].bankkartya;
    }

    // kiírjuk a megadott neveket és bankkártyaszámokat
    cout << "\nBejegyzések:" << endl;
    for (int i = 0; i < index; i++)
    {
        cout << nah[i].keresztnev  << " "
             << nah[i].vezeteknev   << "/"
             << nah[i].bankkartya << endl;
    }

    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
