// ObjHivÁtadás - egy objektum tartalmának módosítása
//                egy függvényben, egy hivatkozás használatával
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;
class Hallgato
{
  public:
    int  feleviOraszam;
    double tanulmanyiAtlag;
};
// ugyanaz, mint eddig, csak most hivatkozásokkal
void egyFv(Hallgato& hivH)
{
    hivH.feleviOraszam = 10;
    hivH.tanulmanyiAtlag = 3.0;
    cout << "A hivH.tanulmanyiAtlag értéke = " <<hivH.tanulmanyiAtlag<< endl; 
}
int main(int nArgSzama, char* mszArg[])
{
    Hallgato h;
    h.tanulmanyiAtlag = 0.0;
    // kiírjuk a h.tanulmanyiAtlag értékét, mielőtt meghívnánk az egyFv()-t
    cout << "A h.tanulmanyiAtlag értéke = " << h.tanulmanyiAtlag << endl;
    // átadjuk a meglévő objektum címét
    cout << "Az egyFv(Hallgato*) meghívása" << endl;
    egyFv(h);
    cout << "Visszatérés az egyFv(Hallgato&) függvényből" << endl;
    // a h.tanulmanyiAtlag értéke most már 3,0
    cout << "A h.tanulmanyiAtlag értéke = " << h.tanulmanyiAtlag << endl;
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
