//  TagokMegsemmisítése - ez a program felépít és
//                        meg is semmisít néhány adattagot
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;
class Kurzus
{
  public:
    Kurzus()  { cout << "kurzus felépítése" << endl; }
    ~Kurzus() { cout << "kurzus megsemmisítése" << endl; }
};
class Hallgato
{
  public:
    Hallgato() { cout << "hallgató felépítése" << endl; }
    ~Hallgato() { cout << "hallgató megsemmisítése" << endl; }
};
class Oktato
{
  public:
    Oktato()
    {
        cout << "oktató felépítése" << endl;
        mK = new Kurzus;
    }
    ~Oktato()
    {
        cout << "oktató megsemmisítése" << endl;
        delete mK;
    }
  protected:
    Kurzus* mK;
};
class KonzulensPar
{
  public:
    KonzulensPar() { cout << "konzulenspár felépítése" << endl; }
   ~KonzulensPar() { cout << "konzulenspár megsemmisítése" << endl; }
  protected:
    Hallgato hallgato;
    Oktato oktato;
};
KonzulensPar* fv()
{
    cout << "KonzulensPar objektum létrehozása az fv() függvényben"
         << endl;
    KonzulensPar kp;
    cout << "KonzulensPar lefoglalása a halommemóriából" << endl;
    KonzulensPar*  mKP = new KonzulensPar;
    cout << "Visszatérés az fv() függvényből" << endl;
    return mKP;
}

int main(int nArgSzama, char* mszArg[])
{
    // meghívjuk az fv() függvényt, majd visszaadjuk
    // a halommemóriába visszatett KonzulensPar objektumot
    KonzulensPar* mKPVisszahelyezett = fv();
    cout << "Halomobjektum visszatétele a halommemóriába" << endl;
    delete mKPVisszahelyezett;
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
