//
//  AdattagokFelépítése - egy adattag felépítése
//                        az alapértelmezettől eltérő értékkel
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

int kovHallgatoiAzon = 1000; // az első szabályos hallgatói azonosító
class HallgatoiAzon
{
  public:
    // az alapértelmezett konstruktor egymást követő azonosítókat oszt ki
    HallgatoiAzon()
    {
        ertek = kovHallgatoiAzon++;
        cout << "A kapott következő hallgatói azonosító: " << ertek << endl;
    }
    // az int konstruktorral a felhasználó oszthat ki azonosítót
    HallgatoiAzon(int azon)
    {
        ertek = azon;
        cout << "A következő hallgatói azonosító hozzárendelése: " << ertek << endl;
    }
  protected:
    int ertek;
};

class Hallgato
{
  public:
    Hallgato(const char *mNev, int khAzon)
      : nev(mNev), azon(khAzon)
    {
        cout << "a következő hallgató felépítése: " << mNev << endl;
    }
  protected:
    string nev;
    HallgatoiAzon azon;
};

int main(int argszama, char* mArg[])
{
    Hallgato h("Morzsi", 1234);
    cout << "Ez egy üzenet a main függvényből" << endl;
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
}
