//  EgymástHívóKonstruktorok - ezzel a funkcióval
//          az egyik konstruktor meghívhatja a másikat
//          ugyanabban az osztályban
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;
class Hallgato
{
  public:
    Hallgato(const char *mNev,
            int atadottOraszam,
            double atadottAtlag)
    {
        cout << "a következő hallgató felépítése: " << mNev << endl;
        nev = mNev;
        feleviOraszam = atadottOraszam;
        tanulmanyiAtlag = atadottAtlag;
    }
    Hallgato() : Hallgato("Névtelen", 0, 0.0) {}
    Hallgato(const char *mNev): Hallgato(mNev, 0, 0.0){}
  protected:
    string  nev;
    int     feleviOraszam;
    double  tanulmanyiAtlag;
};

int main(int argszama, char* mArg[])
{
    // az alábbiakban három különböző konstruktort hívunk meg
    Hallgato nevtelen;
    Hallgato elsoeves("Sebes Mária");
    Hallgato cserediak("Kocsis Károly", 80, 2.5);
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
