//  TagokFelépítéseInicializálókkal - ez a program
//          bemutatja, mi történik egy inicializálóval
//          rendelkező adattag felépítésekor
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;
class HallgatoiAzon
{
  public:
    HallgatoiAzon(int azon) : ertek(azon)
    {
        cout << "azon = " << ertek << endl;
    }
  protected:
    int ertek;
};
int kovHallgatoiAzon = 1000;
class Hallgato
{
  public:
    Hallgato(const char *mNev, int khAzon)
      : nev(mNev), azon(khAzon)
    {
        cout << "a következő hallgató felépítése: " << mNev << endl;
    }
    Hallgato(const char *mNev): nev(mNev)
    {
        cout << "a következő hallgató felépítése: " << mNev << endl;
    }
  protected:
    string nev;
    HallgatoiAzon azon = kovHallgatoiAzon++;
};
int main(int argszama, char* mArg[])
{
    Hallgato h1("Morzsi", 1234);
    Hallgato h2("Bodri");
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
