//
//  TömbFelépítése - egy objektumtömb felépítése
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <string.h>

using namespace std;
class Hallgato
{
  public:
    Hallgato()
    {
        cout << "Névtelen hallgató felépítése" << endl;
        nev = "Névtelen";
        feleviOraszam = 0;
        tanulmanyiAtlag = 0.0;
    }
    Hallgato(const char *mNev)
    {
        cout << "a következő hallgató felépítése: " << mNev << endl;
        nev = mNev;
        feleviOraszam = 0;
        tanulmanyiAtlag = 0;
    }
    Hallgato(const char *mNev, int atadottOraszam, float atadottAtlag)
    {
        cout << "a következő hallgató felépítése: " << mNev << endl;
        nev = mNev;
        feleviOraszam = atadottOraszam;
        tanulmanyiAtlag = atadottAtlag;
    }
  protected:
    string  nev;
    int     feleviOraszam;
    float   tanulmanyiAtlag;
};


// ...ugyanaz a Hallgato osztály, túlterhelt konstruktorokkal...
int main(int argszama, char* mArg[])
{
    // az alábbiakban három különböző konstruktort hívunk meg
    Hallgato h[]{"Sebes Mária", "Kocsis Károly"};
    Hallgato i[]{{"Morzsi", 0, 0.0}, {"Bodri", 12, 2.5}};
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
