//
//  ÁthelyezésMásolás  - bemutatja az ideiglenes objektumok
//                       másolás helyetti áthelyezésének elvét
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;
class Szemely
{
  public:
    Szemely(const char *mN)
    {
        mNev = new string(mN);
        cout << *mNev << " felépítése" << endl;
    }
    Szemely(Szemely& sz)
    {
        cout << *sz.mNev << " másolása" << endl;
        mNev = new string(" másolata");
        *mNev += *sz.mNev;
    }
    Szemely(Szemely&& sz)
    {
        cout << *sz.mNev << " áthelyezése" << endl;
        mNev = sz.mNev;
        sz.mNev = nullptr;
    }
    ~Szemely()
    {
        if (mNev)
        {
            cout << *mNev << " megsemmisítése" << endl;
            delete mNev;
        }
        else
        {
            cout << "Null értékű objektum megsemmisítése" << endl;
        }
    }
 protected:
    string* mNev;
};
Szemely fv2(Szemely sz)
{
    cout << "Belépés az fv2-be" << endl;
    return sz;
}
Szemely fv1(char* mNev)
{
    cout << "Belépés az fv1-be"  << endl;
    return fv2(*new Szemely(mNev));
}
int main(int argszama, char* mArg[])
{
    Szemely t(fv1("Bodri"));
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
