//  TúlterhelésFelüldefiniálás - azt szemlélteti, amikor egy függvény
//     fordítási időben van túlterhelve, illetve futásidőben van felülbírálva
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;
class Hallgato
{
  public:
    // vedd ki a megjegyzésből az egyiket vagy a másikat
    // a következő két sor közül; az egyik korán köti a tandijKiszamitas()-t,
    // a másik pedig későn
    void tandijKiszamitas()
//  virtual void tandijKiszamitas() 
    {
        cout << "Ez a Hallgato::tandijKiszamitas" << endl;
    }
};
class VegzosHallgato : public Hallgato
{
  public:
    void tandijKiszamitas()
    {
      cout << "Ez a VegzosHallgato::tandijKiszamitas" << endl;
    }
};
void fv(Hallgato& x)
{
    x.tandijKiszamitas(); // ez melyik tandijKiszamitas()?
}
int main(int nArgSzama, char* mszArg[])
{
    // átadunk egy alaposztályú objektumot a függvénynek
    // (hogy megfeleljen a deklarációnak)
    Hallgato h;
    fv(h);
    // inkább az alaposztály egy specializációját adjuk át
    VegzosHallgato vh;
    fv(vh);
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
