// ÁthelyezőOperátorBemutató - szemléleti az áthelyező operátort
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <cstring>
using namespace std;
class EnTarolom
{
  public:
    EnTarolom(int nS, const char* pS) : nMeret(nS)
    {
        mSztring = new char[nMeret];
        strcpy(mSztring, pS);
    }
    ~EnTarolom()
    {
        delete mSztring;
        mSztring = nullptr;
    }
    //másoló konstruktor
    EnTarolom(const EnTarolom& s)
    {
        masolas(*this, s);
    }
    EnTarolom& operator=(EnTarolom& s)
    {
        delete mSztring;
        masolas(*this, s);
        return *this;
    }
    // áthelyező konstruktor
    EnTarolom(EnTarolom&& s)
    {
        athelyezes(*this, s);
    }
    EnTarolom& operator=(EnTarolom&& s)
    {
        delete mSztring;
        masolas(*this, s);
        return *this;
    }
  protected:
    static void athelyezes(EnTarolom& cel, EnTarolom& forras)
    {
        cout << forras.mSztring << " áthelyezése" << endl;
        cel.nMeret = forras.nMeret;
        cel.mSztring = forras.mSztring;
        forras.nMeret = 0;
        forras.mSztring = nullptr;
    }
    static void masolas(      EnTarolom& cel,
                       const EnTarolom& forras)
    {
        cout << forras.mSztring << " másolása" << endl;
        delete cel.mSztring;
        cel.nMeret = forras.nMeret;
        cel.mSztring = new char[cel.nMeret];
        strncpy(cel.mSztring, forras.mSztring, cel.nMeret);
    }
    int nMeret;
    char* mSztring;
};
EnTarolom fv(int n, const char* mSztring)
{
    EnTarolom b(n, mSztring);
    return b;
}
int main(int nArgSzama, char* mszArg[])
{
    EnTarolom et(100, "Eredeti");
    et = fv(100, "Létrehozva az fv()-ben");
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
