//  FaktoriálisKivétel - szemlélteti a kivételeket
//                       egy faktoriális függvénnyel
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;
// faktorialis - kiszámítja a faktoriálist
int faktorialis(int n)
{
    // nem tudjuk kezelni, ha az n értéke negatív;
    // jobb, ha előbb ellenőrizzük ezt a feltételt
    if (n < 0)
    {
        throw string("A faktoriális argumentuma negatív");
    }
    // továbblépünk, és kiszámítjuk a faktoriálist
    int gyujto = 1;
    while(n > 0)
    {
        gyujto *= n;
        n--;
    }
    return gyujto;
}
int main(int nArgSzama, char* mszArg[])
{
    try
    {
        // ez működni fog
        cout << "A 3 faktoriális értéke "
             << faktorialis(3) << endl;
        // ez kivételt fog generálni
        cout << "A -1 faktoriális értéke "
             << faktorialis(-1) << endl;
        // a vezérlés soha nem fog eljutni ide
        cout << "Az 5 faktoriális értéke "
             << faktorialis(5) << endl;
    }
    // a vezérlés ide kerül át
    catch(string hiba)
    {
        cout << "Hiba történt: " << hiba << endl;
    }
    catch(...)
    {
        cout << "Alapértelmezett kezelés " << endl;
    }
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
