//  TöbbszörösÖröklődésÚjrabontás - egyetlen osztály
//                  több alaposztálytól is örökölhet
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
#define PROBA false
using namespace std;
// Butor - alapvetőbb fogalom; ez az osztály
//         rendelkezik a "suly" tulajdonsággal
class Butor
{
  public:
    Butor(int s) : suly(s) {}
    int suly;
};
class Agy : public Butor
{
  public:
    Agy(int suly) : Butor(suly) {}
    void alvas(){ cout << "Alvás" << endl; }
};
class Kanape : public Butor
{
  public:
    Kanape(int suly) : Butor(suly) {}
    void TVnezes(){ cout << "TV-nézés" << endl; }
};
// KihuzhatoKanape - ágy és kanapé is egyben
class KihuzhatoKanape : public Agy, public Kanape
{
  public:
    KihuzhatoKanape(int suly) : Agy(suly), Kanape(suly) {}
    void kihuzas(){ cout << "Kihúzás" << endl; }
};
int main(int nArgSzama, char* mszArg[])
{
    KihuzhatoKanape kk(10);
    // 1. rész -
    // ez nem egyértelmű; ez most
    // Butor::Kanape vagy Butor::Agy?
#if PROBA
    cout << "Súly = " << kk.suly << endl;
#endif
    // 2. rész -
    // ez egyértelműen megadja az öröklődési
    // útvonalat, de igazából a hatását elrontja
    KihuzhatoKanape* mKK = &kk;
    Kanape* mKanape = (Kanape*)mKK;
    Butor* mButor = (Butor*)mKanape;
    cout << "Súly = " << mButor->suly << endl;
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
