//  VirtuálisÖröklődés - virtuális öröklődéssel az
//            Agy és a Kanape osztály közös alaposztályt használhat
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;
// Butor - alapvetőbb fogalom; ez az osztály
//         rendelkezik a "suly" tulajdonsággal
class Butor
{
  public:
    Butor(int s) : suly(s) {}
    int suly;
};
class Agy : virtual public Butor
{
  public:
    Agy(int s = 0) : Butor(s) {}
    void alvas(){ cout << "Alvás" << endl; }
};
class Kanape : virtual public Butor
{
  public:
    Kanape(int s = 0) : Butor(s) {}
    void TVnezes(){ cout << "TV-nézés" << endl; }
};
// KihuzhatoKanape - ágy és kanapé is egyben
class KihuzhatoKanape : public Agy, public Kanape
{
  public:
    KihuzhatoKanape(int s) : Butor(s) {}
    void kihuzas(){ cout << "Kihúzás" << endl; }
};
int main(int nArgSzama, char* mszArg[])
{
    KihuzhatoKanape kk(10);
    // ez már nem kétértelmű;
    // az Agy és a Kanape már csak egy súlyon osztozik
    // Butor::Kanape vagy Butor::Agy?
    cout << "Súly = " << kk.suly << endl;
    // várakozás a program leállításával, amíg a felhasználó készen áll,
    // hogy a felhasználó láthassa a program eredményeit
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
