// NincsPufferTúlcsordulás2 - ez a program úgy kerüli el a hekkelést,
//                            hogy változó méretű puffert használ
#include <cstdio>
#include <cstdlib>
#include <fstream>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
using namespace std;
// sztringBeolvasas - egy bementi sztringet olvas be a felhasználói promptról, 
//                    és visszaadja azt a hívónak
char* sztringBeolvasas(istream& cin)
{
    // létrehozunk egy változó méretű puffert 64 karakteres 
    // kezdeti hosszal; ez a puffer viszont tovább 
    // növelhető, ha több, mint 64 karakter van a
    // bemeneti fájlban
    vector<char> puffer;
    puffer.reserve(64);
    // most betöltünk egy sztringet a fájlból
    for(;;)
    {
        // beolvassuk a következő karaktert
        char c = cin.get();
        // kilépünk a ciklusból, ha a beolvasott karakter NULL vagy EOF
        if ((c == 0) || cin.eof())
        {
            break;
        }
         // hozzáadjuk a karaktert a pufferhez, és növeljük a 
         // puffer méretét, ha ez szükséges a tároláshoz
         puffer.push_back(c);
   }
    // biztosítjuk, hogy a puffer nullal záruljon
    puffer.push_back('\0');
    // a sztring másolatát adja vissza a hívónak
    char* mP = new char[puffer.size()];
    if (mP != nullptr)
    {
        strcpy(mP, puffer.data());
    }
    return mP;
}

int main(int argszama, char* mArg[])
{
    // bekérjük a beolvasandó fájl nevét
    cout <<"Ez a program egy bemeneti fájlból olvassa be a bemenetet\n"
           "Add meg a fájl nevét:";
    string szNev;
    cin >> szNev;
    // megnyitjuk a fájlt
    ifstream c(szNev.c_str());
    if (!c)
    {
        cout << "\nHiba történt a bemeneti fájl megnyitásakor" << endl;
        exit(-1);
    }
    // beolvassuk a fájl tartalmát egy sztringbe
    char* mP = sztringBeolvasas(c);
    // kiírjuk, amit kaptunk
    cout << "\nA következőket sikerült beolvasni:\n" << mP << endl;
    cout << "A folytatáshoz nyomd meg az Entert..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    printf("Kész!");
    exit(0);
    return 0;
}
